#include "appli.h"

// Do not forget to append _CRT_SECURE_NO_WARNINGS in :
// project properties > Configuration properties > C/C++ > Preprocessor > Preprocessor definitions
// If you do not do so, you just might get annoying warnings while compiling (happens on Visual Studio)

LRESULT CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	char Path[256],LeftPart[64],RightPart[64],MainFolder[128],buff[128];
	int VariantLow,VariantHigh,i,DigitsLow,DigitsHigh,Digits,Focus;
	HWND CurrentFocus;

	switch(uMsg)
	{
	//Maybe there is a way to manage keystrokes using personal classes and stuff but
	//I prefer using my own method, like this I perfectly know what behavior I am expecting ;)
	//The WM_KEYDOWN message is manually sent in WinMain.c since it would appear that this message is processed instead of being simply dispatched.
	//The simple SendMessage was my simple way of making this WM_KEYDOWN correctly sent, but I think it shall work with every other message :D
	case WM_KEYDOWN: 
		switch(wParam)
		{
		case VK_RETURN:
			CurrentFocus=GetFocus();
			if(CurrentFocus==GetDlgItem(hDlgMain,ID_SINGLE_PROCESS)) goto LabelSingleProcess;
			if(CurrentFocus==GetDlgItem(hDlgMain,ID_MULTI_PROCESS)) goto LabelMultiProcess;
			break;
		
		//It is my manual tab order, since it will not work at all, despite the order I set using Ctrl+D in the resource editor.
		case VK_TAB:	
			CurrentFocus=GetFocus();
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_SINGLE_PATH))		Focus=1;
			if(CurrentFocus==GetDlgItem(hDlgMain,ID_SINGLE_PROCESS))	Focus=2;
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_MULTI_PATH))		Focus=3;
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_MULTI_LEFTPART))	Focus=4;
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_MULTI_NBLOW))		Focus=5;
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_MULTI_NBHIGH))		Focus=6;
			if(CurrentFocus==GetDlgItem(hDlgMain,IDC_MULTI_RIGHTPART))	Focus=7;
			if(CurrentFocus==GetDlgItem(hDlgMain,ID_MULTI_PROCESS))		Focus=8;
			switch(Focus)
			{
			case 1:
				SetFocus(GetDlgItem(hDlgMain,ID_SINGLE_PROCESS));
				break;
			case 2:
				SetFocus(GetDlgItem(hDlgMain,IDC_MULTI_PATH));
				break;
			case 3:
				SetFocus(GetDlgItem(hDlgMain,IDC_MULTI_LEFTPART));
				break;
			case 4:
				SetFocus(GetDlgItem(hDlgMain,IDC_MULTI_NBLOW));
				break;
			case 5:
				SetFocus(GetDlgItem(hDlgMain,IDC_MULTI_NBHIGH));
				break;
			case 6:
				SetFocus(GetDlgItem(hDlgMain,IDC_MULTI_RIGHTPART));
				break;
			case 7:
				SetFocus(GetDlgItem(hDlgMain,ID_MULTI_PROCESS));
				break;
			case 8:
				SetFocus(GetDlgItem(hDlgMain,IDC_SINGLE_PATH));
				break;

			default:
				break;
			}

			break;
		}
		break;

	case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case ID_ONLINEHELP:	//"Online tutorial" button
				ShellExecute(NULL, "open", "http://shinkel.over-blog.com/pages/commangagui-english-tutorial-8610079.html", NULL, NULL, SW_SHOWNORMAL);	
				break;
	
			case IDM_EXIT:	//"File" > "Exit" menu item
				goto LabelMenuExit;
				break;

			case IDM_ABOUT:	//"About" menu item
				MessageBox(hDlgMain,
					"Based on ComManga by F. Gros, 2013\n\nComMangaGUI v1.0 by Shinkel, 2013.",
					"ComMangaGUI v1.0"
					,MB_OK);
				break;

			case ID_SINGLE_PROCESS:	//If "Proceed to CBZ creation (single)" button is pressed
LabelSingleProcess:
				// Erasing Paths receiver buffer
				ZeroMemory(Path,sizeof Path);
				
				// Collecting Path from edit box
				GetDlgItemText(hDlgMain,IDC_SINGLE_PATH,Path,sizeof Path);

				ComManga(Path);
				break;

			case ID_MULTI_PROCESS:
LabelMultiProcess:
				// Erasing variables
				ZeroMemory(MainFolder,sizeof MainFolder);	//Main folder path
				ZeroMemory(LeftPart,sizeof LeftPart);		//Left part of the name of each volume directory
				ZeroMemory(RightPart,sizeof RightPart);		//Right part of the name of each volume directory
				ZeroMemory(buff,sizeof buff);				//Temporary buffer
				VariantLow=0;								//Low variant of each volume directory
				VariantHigh=0;								//High variant of each volument directory
				DigitsLow=0;								//Digits for the low variant
				DigitsHigh=0;								//Digits for the high variant
				Digits=0;									//Digits that will be used for naming


				GetDlgItemText(hDlgMain,IDC_MULTI_PATH,MainFolder,sizeof MainFolder);
				GetDlgItemText(hDlgMain,IDC_MULTI_LEFTPART,LeftPart,sizeof LeftPart);
				GetDlgItemText(hDlgMain,IDC_MULTI_RIGHTPART,RightPart,sizeof RightPart);
				
				DigitsLow=GetDlgItemText(hDlgMain,IDC_MULTI_NBLOW,buff,sizeof buff);
				VariantLow=atoi(buff);	//Unfortunately, 0 is a valid number AND the error return value.So, it is not possible to check consistency of the low part.
				
				ZeroMemory(buff,sizeof buff);
				
				DigitsHigh=GetDlgItemText(hDlgMain,IDC_MULTI_NBHIGH,buff,sizeof buff);
				if((VariantHigh=atoi(buff))==0)	//But here, since 0 should not be the the high variant, we can safely consider 0 as an invalid value.
				{
					MsgBox("ERROR : high variant part is not a valid number (not a number or 0).");
					break;
				}

				//Digits is a very important variable. For example, "Manga t01" has 2 digits, if 3 are set, the path to the folder will be "Manga t001", so a wrong path.
				//Anyway, if a mismatch is entered (for example "02" as the low variant and "010" as the high variant), the higher will be chosen.
				//As a safety, a maximum of 4 digits is taken. Because there is no manga series that has more than 9999 mangas...
				//If however one day such thing happens, the code modification is pretty straightforward.
				if(DigitsLow>=DigitsHigh)
				{
					Digits=DigitsLow;
				}
				else
				{
					Digits=DigitsHigh;
				}
				if(Digits>4)
				{
					WriteToLB("WARNING : Maximum admissible digits is 4. Digits count is set to 4.");
					Digits=4;
				}


				// A little check of the 2 values (but does not detect when Low part is an invalid value in all cases)
				if(VariantHigh<=VariantLow)
				{
					WriteToLB("WARNING : High and low variant may be inverted. Inverting the values.");
					i=VariantHigh;
					VariantHigh=VariantLow;
					VariantLow=i;
					if(VariantHigh<=VariantLow)
					{
						MsgBox("ERROR : High or low variant parameter inconsistency (possible reason : low variant is not a number.");
						break;
					}
				}
				
				for(i=VariantLow;i<=VariantHigh;i++)
				{
					switch(Digits)
					{
					case 1:
						sprintf(Path,"%s\\%s%01d%s",MainFolder,LeftPart,i,RightPart);
						WriteToLB(Path);
						break;

					case 2:
						sprintf(Path,"%s\\%s%02d%s",MainFolder,LeftPart,i,RightPart);
						WriteToLB(Path);
						break;

					case 3:
						sprintf(Path,"%s\\%s%03d%s",MainFolder,LeftPart,i,RightPart);
						WriteToLB(Path);
						break;

					case 4:
						sprintf(Path,"%s\\%s%04d%s",MainFolder,LeftPart,i,RightPart);
						WriteToLB(Path);
						break;

					default:
						WriteToLB("ERROR : Digits error in variant loop");
						break;
					}

					//Call ComManga()
					ComManga(Path);

					ZeroMemory(Path,sizeof Path);

				}
				break;
			}
			break;

	case WM_CLOSE:
LabelMenuExit:
			EndDialog(hDlg,0);
			exit(0);
			break;

	case WM_INITDIALOG:
			hDlgMain=hDlg;

			//Necessary to get the handle of the ListBox that allows the user to be kept in touch while using this program
			hLB=GetDlgItem(hDlgMain,IDC_INFO);
			WriteToLB("Welcome to ComMangaGUI!");
			
			//Sets the focus to the first editbox
			SetFocus(GetDlgItem(hDlgMain,IDC_SINGLE_PATH));

			

			break;
		}
	return 0;
}